Codeforces 276C - Little Girl and Maximum Sum(题解)

2024-04-10 20:20

本文主要是介绍Codeforces 276C - Little Girl and Maximum Sum(题解),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

 原题地址:https://codeforces.com/problemset/problem/276/C

分析:乍一看以为简单的 数组区间求和,快速 query,结果不是。

题目说,在给定的 q 组区间下,能否将数组调整成 某一种顺序,使得这 q 组区间查询结果 得到的所有结果之和,尽可能最大。

所以变成了:我们需要统计这 q 组区间查询下,哪些数组元素位置 pos 被区间命中的次数最多。

哪一个位置次数最多,那么把这个位置,给调整成数组的最大元素,次数第二多,此处数组值调整成数组的第二大元素,....,依此类推。

涉及三个技巧:

1.数组区间片段,快速求命中次数,采用一个 segmentStart,segmentEnd 标记数组,和一个标记变量 cur,采用累进方式,统计当前位置 arr[pos] 的命中次数。

2. 对元素在片段中的命中次数,以及 原数组,两个数组排序。然后结果是  occurence[i] * arraySortDesc[i]  累加之和。

3. 因为采用的是 Java 实现,测试集中有 20000 级别的 大数据量 input 用例,所以不能用一般的 `Scanner(System.in)`,而要用一个 Buffer 的 FasterReader 类,参考下方代码。

以下是完整 Java AC 代码。

// AC: 624 ms 
// Memory: 11600 KB
// Array Segment count & Sort: We need to find the most frequency position, and assign with the maximum value of the array, 
// then the next frequency position, and assign with the second maximum value of array.
// Notice: Using FasterReader class instead of `Scanner(System.in)`, otherwise the Java solution could TLE.
// T:O(nlogn), S:O(n)
// 
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.PriorityQueue;
import java.util.StringTokenizer;public class Codeforces_0276C_Little_Girl_and_Maximum_Sum {private static class FastReader {BufferedReader br;StringTokenizer st;public FastReader() {br = new BufferedReader(new InputStreamReader(System.in));}String next() {while (st == null || !st.hasMoreElements()) {try {st = new StringTokenizer(br.readLine());} catch (IOException e) {e.printStackTrace();}}return st.nextToken();}int nextInt() {return Integer.parseInt(next());}long nextLong() {return Long.parseLong(next());}double nextDouble() {return Double.parseDouble(next());}String nextLine() {String str = "";try {str = br.readLine();} catch (IOException e) {e.printStackTrace();}return str;}}public static void main(String[] args) {FastReader sc = new FastReader();int n = sc.nextInt(), q = sc.nextInt();long ret = 0;Integer[] arr = new Integer[n];int[] segmentStart = new int[n], segmentEnd = new int[n];for (int i = 0; i < n; i++) {arr[i] = sc.nextInt();}for (int i = 0; i < q; i++) {int l = sc.nextInt(), r = sc.nextInt();segmentStart[l - 1]++;segmentEnd[r - 1]++;}int cur = 0;PriorityQueue<Integer> countOccurence = new PriorityQueue<>((o1, o2) -> o2 - o1);for (int i = 0; i < n; i++) {if (segmentStart[i] > 0) {cur += segmentStart[i];}if (cur > 0) {countOccurence.offer(cur);}if (segmentEnd[i] > 0) {cur -= segmentEnd[i];}}Arrays.sort(arr);int pos = n - 1;while (!countOccurence.isEmpty()) {int occurence = countOccurence.poll();ret += (long) occurence * arr[pos--];}System.out.println(ret);}
}

这篇关于Codeforces 276C - Little Girl and Maximum Sum(题解)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/892047

相关文章

最大流=最小割=最小点权覆盖集=sum-最大点权独立集

二分图最小点覆盖和最大独立集都可以转化为最大匹配求解。 在这个基础上,把每个点赋予一个非负的权值,这两个问题就转化为:二分图最小点权覆盖和二分图最大点权独立集。   二分图最小点权覆盖     从x或者y集合中选取一些点,使这些点覆盖所有的边,并且选出来的点的权值尽可能小。 建模:     原二分图中的边(u,v)替换为容量为INF的有向边(u,v),设立源点s和汇点t

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

C++ | Leetcode C++题解之第393题UTF-8编码验证

题目: 题解: class Solution {public:static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num &

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

C语言 | Leetcode C语言题解之第393题UTF-8编码验证

题目: 题解: static const int MASK1 = 1 << 7;static const int MASK2 = (1 << 7) + (1 << 6);bool isValid(int num) {return (num & MASK2) == MASK1;}int getBytes(int num) {if ((num & MASK1) == 0) {return

C - Word Ladder题解

C - Word Ladder 题解 解题思路: 先输入两个字符串S 和t 然后在S和T中寻找有多少个字符不同的个数(也就是需要变换多少次) 开始替换时: tips: 字符串下标以0开始 我们定义两个变量a和b,用于记录当前遍历到的字符 首先是判断:如果这时a已经==b了,那么就跳过,不用管; 如果a大于b的话:那么我们就让s中的第i项替换成b,接着就直接输出S就行了。 这样

【秋招笔试】9.07米哈游秋招改编题-三语言题解

🍭 大家好这里是 春秋招笔试突围,一起备战大厂笔试 💻 ACM金牌团队🏅️ | 多次AK大厂笔试 | 大厂实习经历 ✨ 本系列打算持续跟新 春秋招笔试题 👏 感谢大家的订阅➕ 和 喜欢💗 和 手里的小花花🌸 ✨ 笔试合集传送们 -> 🧷春秋招笔试合集 🍒 本专栏已收集 100+ 套笔试题,笔试真题 会在第一时间跟新 🍄 题面描述等均已改编,如果和你笔试题看到的题面描述